Summary: Database-specific drivers for libdbi
Name: libdbi-drivers
Version: 0.9.0
Release:    1%{?dist}
License: LGPLv2+
URL: http://libdbi-drivers.sourceforge.net/

Source0: http://prdownloads.sourceforge.net/libdbi-drivers/%{name}-%{version}.tar.gz
Patch1: libdbi-drivers-aarch64.patch
Patch2: libdbi-drivers-sys-wait.patch
Patch3: libdbi-drivers-0.9.0-buffer_overflow.patch

Requires: libdbi >= 0.9
BuildRequires: libdbi-devel >= 0.9
BuildRequires: autoconf openjade docbook-style-dsssl
BuildRequires: gcc

%description
libdbi implements a database-independent abstraction layer in C, similar to the
DBI/DBD layer in Perl. Writing one generic set of code, programmers can
leverage the power of multiple databases and multiple simultaneous database
connections by using this framework.

libdbi-drivers contains the database-specific plugins needed to connect
libdbi to particular database servers.

%package -n libdbi-dbd-mysql
Summary: MySQL plugin for libdbi
Requires:	%{name} = %{version}-%{release}
BuildRequires: mariadb-connector-c-devel, openssl-devel

%description -n libdbi-dbd-mysql
This plugin provides connectivity to MySQL/MariaDB database servers through
the libdbi database independent abstraction layer. Switching a program's
plugin does not require recompilation or rewriting source code.

%package -n libdbi-dbd-pgsql
Summary: PostgreSQL plugin for libdbi
Requires:	%{name} = %{version}-%{release}
BuildRequires: libpq-devel, krb5-devel, openssl-devel

%description -n libdbi-dbd-pgsql
This plugin provides connectivity to PostgreSQL database servers through the
libdbi database independent abstraction layer. Switching a program's plugin
does not require recompilation or rewriting source code.

%package -n libdbi-dbd-sqlite
Summary: SQLite plugin for libdbi
Requires:	%{name} = %{version}-%{release}
BuildRequires: sqlite-devel
BuildRequires: make

%description -n libdbi-dbd-sqlite
This plugin provides access to an embedded SQL engine using libsqlite3 through
the libdbi database independent abstraction layer. Switching a program's plugin
does not require recompilation or rewriting source code.

%prep
%setup -q -n %{name}-%{version}
%patch1 -p1
%patch2 -p1
%patch3 -p1
autoconf
sed -i -r 's|<(mysql\.h)>|<mysql/\1>|' drivers/mysql/dbd_mysql.c
sed -i -r "s|(SQLITE3_LIBS=)-lsqlite[^[:space:]]*|\1$(pkg-config --libs-only-l sqlite3)|" \
  configure

%build
%configure --with-mysql --with-pgsql --with-sqlite3 \
	--with-mysql-libdir=%{_libdir}/mariadb \
	--with-mysql-incdir=%{_includedir} \
	--with-pgsql-libdir=%{_libdir} \
	--with-pgsql-incdir=%{_includedir} \
	--with-sqlite3-libdir=%{_libdir} \
	--with-sqlite3-incdir=%{_includedir} \
	--with-dbi-libdir=%{_libdir}

make %{?_smp_mflags}

%install
make DESTDIR=%{buildroot} install

rm -f %{buildroot}%{_libdir}/dbd/*.a
rm -f %{buildroot}%{_libdir}/dbd/*.la

rm -rf %{buildroot}%{_docdir}/%{name}-%{version}


%files
%doc AUTHORS ChangeLog COPYING README
%doc drivers/mysql/dbd_mysql/*.html
%doc drivers/mysql/*.pdf
%doc drivers/pgsql/dbd_pgsql/*.html
%doc drivers/pgsql/*.pdf
%doc drivers/sqlite3/dbd_sqlite3/*.html
%doc drivers/sqlite3/*.pdf
%dir %{_libdir}/dbd

%files -n libdbi-dbd-mysql
%{_libdir}/dbd/libdbdmysql.*

%files -n libdbi-dbd-pgsql
%{_libdir}/dbd/libdbdpgsql.*

%files -n libdbi-dbd-sqlite
%{_libdir}/dbd/libdbdsqlite3.*

%changelog
* Thu Aug 15 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.9.0-1
- initial build
